<?php
if(isset($_POST['action'])) {
	$AjaxRequest = true;
} else {
	$AjaxRequest = false;
	if(!defined("IQ_AUTH_CORE_DIR")) { die(); }
}

$DataValuesArr = [];
if($AjaxRequest) {
	if(!isset($_SERVER['HTTP_REFERER'])) {
		die();
	}
	sleep(1);
	
	if(!isset($_POST['Values'])) {
		die();
	}
	
	$bPop = false;
	if(isset($_POST['Pop'])) {
		$bPop = (int)sanitize_text_field($_POST['Pop']);
	}
	if($bPop) {
		$szPreTag = 'pop_';
	} else {
		$szPreTag = '';
	}
	
	#######################
	##### DATA VALUES #####
	#######################
	$DataJsonStrArr = array();
	$PostValues = sanitize_text_field($_POST['Values']);
	$Exp = explode(',', $PostValues);
	$ArrayData = array();
	for($i = 0; $i < count($Exp); $i++) {
		$TempParam = trim($Exp[$i]);
		if(empty($TempParam)) { continue; }
		$ArrayData[] = $TempParam;
	}

	if(empty($ArrayData)) {
		die();
	}
	
	// iq_lost_email
	$Key = $szPreTag.'iq_lost_email';
	if(!in_array($Key, $ArrayData) || !isset($_POST[$Key])) {
		$szMsg = esc_html__('Enter email', 'registration-and-authorize');
		die($szMsg);
	}
	$DataValuesArr['iq_email'] = sanitize_email($_POST[$Key]);
	if(empty($DataValuesArr['iq_email'])) {
		$szMsg = esc_html__('Enter email', 'registration-and-authorize');
		die($szMsg);
	}
	
} else {
	// iq_lost_email
	$Key = $szPreTag.'iq_lost_email';
	if(!isset($_POST[$Key]) || empty($_POST[$Key])) {
		$szErr = esc_html__('Enter email', 'registration-and-authorize');
		$bErr = true;
		return;
	}
	$DataValuesArr['iq_email'] = sanitize_email($_POST[$Key]);
	if(empty($DataValuesArr['iq_email'])) {
		$szErr = esc_html__('Enter email', 'registration-and-authorize');
		$bErr = true;
		return;
	}
}

if(!isset($iq_auth_settings_arr)) {
	$iq_auth_settings_arr = func_iq_auth_get_settings();
}

$redirect_url = '/';
if(isset($iq_auth_settings_arr['auth_redirect'])) {
	$redirect_url = '/'.$iq_auth_settings_arr['auth_redirect'];
}
if(isset($iq_auth_settings_arr['lost_url'])) {
	$lost_url = '/'.$iq_auth_settings_arr['lost_url'];
} else {
	$lost_url = '/'.IQ_AUTH_LOST_PAGE_DEF;
}

######################
##### VALIDATION #####
######################
// def inputs
$DefArr['email'] = [
	'name' => 'Email',
	'regex' => '/^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/',
	'min' => 2,
	'max' => 64,
];

$FormVal = [];

$bSkip = false;
foreach($DefArr AS $key => $data) {
	$FormVal[$key.'_length'] = $data['min'].':'.$data['max'];
	if(isset($iq_auth_settings_arr[$key.'_length'])) {
		$FormVal[$key.'_length'] = $iq_auth_settings_arr[$key.'_length'];
	}
	$Exp = explode(':', $FormVal[$key.'_length']);
	$FormVal[$key.'_length_min'] = (int)$Exp[0];
	$FormVal[$key.'_length_max'] = (int)$Exp[1];
	
	$KeyPost = 'iq_'.$key;
	if(func_iq_auth_get_count_letter($DataValuesArr['iq_'.$key]) < $FormVal[$key.'_length_min'] || func_iq_auth_get_count_letter($DataValuesArr['iq_'.$key]) > $FormVal[$key.'_length_max']) {
		$szMsg = sprintf(esc_html__('The length of the «%s» field must be between %s and %s characters', 'registration-and-authorize'), $data['name'], $FormVal[$key.'_length_min'], $FormVal[$key.'_length_max']);
		
		if($AjaxRequest) {
			echo esc_html($szMsg);
			die();
		}
		$szErr = $szMsg;
		$bErr = true;
		$bSkip = true;
	}
	if($bSkip) {
		break;
	}
	
	// regex
	$FormVal[$key.'_regex'] = '';
	if(isset($iq_auth_settings_arr[$key.'_regex'])) {
		$FormVal[$key.'_regex'] = stripcslashes($iq_auth_settings_arr[$key.'_regex']);
	}
	if(!empty($FormVal[$key.'_regex'])) {
		if(preg_match($FormVal[$key.'_regex'], $DataValuesArr['iq_'.$key]) !== 1) {
			if(isset($iq_auth_settings_arr[$key.'_regex_text']) && !empty($iq_auth_settings_arr[$key.'_regex_text'])) {
				$szMsg = stripcslashes($iq_auth_settings_arr[$key.'_regex_text']);
			} else {
				$szMsg = sprintf(esc_html__('Incorrect field value «%s»', 'registration-and-authorize'), $data['name']);
			}
			if($AjaxRequest) {
				echo esc_html($szMsg);
				die();
			}
			$szErr = $szMsg;
			$bErr = true;
			
			$bSkip = true;
		}
	}
	if($bSkip) {
		break;
	}
}
if($bSkip) { 
	return;
}
	
if ( is_user_logged_in() ) {
	if($AjaxRequest) {
		?>
		<div id="auth_already">
			<input type="hidden" id="temp_redirect_url" value="<?php echo esc_attr($redirect_url); ?>">
			<?php echo esc_html__('You are already logged in', 'registration-and-authorize'); ?>
		</div>
		<?php
		die();
	}
	wp_redirect($redirect_url);
	return;
}

if(!isset($cIQAuthClass)) {
	require_once IQ_AUTH_CORE_DIR.'/includes/inc_auth.php';
	$cIQAuthClass = new IQAuthClass();
}

###################
##### CAPTCHA #####
###################
$service_lost = 'lost_try';
$bCaptcha = false;
$bCaptchaShow = false;
if(isset($iq_auth_settings_arr['lost_captcha_enable']) && (int)$iq_auth_settings_arr['lost_captcha_enable']) {
	if(isset($iq_auth_settings_arr['captcha_pub']) && !empty($iq_auth_settings_arr['captcha_pub']) && isset($iq_auth_settings_arr['captcha_secret']) && !empty($iq_auth_settings_arr['captcha_secret'])) {
		$bCaptcha = true;
	}
}

$iCaptchaLimitFree = 0;
if($bCaptcha) {
	if(isset($iq_auth_settings_arr['captcha_limit_free']) && (int)$iq_auth_settings_arr['captcha_limit_free']) {
		$iCaptchaLimitFree = (int)$iq_auth_settings_arr['captcha_limit_free'];
		$iCountTry = $cIQAuthClass->antifloodGetCount($service_lost);
		if($iCountTry >= (int)$iCaptchaLimitFree) {
			$bCaptchaShow = true;
		}
	} else {
		// Always
		$bCaptchaShow = true;
	}
}

if($bCaptcha && $bCaptchaShow) {
	// Show captcha
	$capcha_key = false;
	if($AjaxRequest) {
		foreach($ArrayData AS $key) {
			if(strpos($key, 'g-recaptcha-response') !== false) {
				if(isset($_POST[$key])) {
					$capcha_key = $key;
					break;
				}
			}
		}
	} else {
		foreach($_POST AS $key => $post_data) {
			if(strpos($key, 'g-recaptcha-response') !== false) {
				$capcha_key = $key;
				break;
			}
		}
	}
	if(!$capcha_key) {
		if($AjaxRequest) {
			?>
			<div id="captcha_block" class="iq_auth_align_center">
				<center>
					<script src="https://www.google.com/recaptcha/api.js" async defer></script>
					<div class="g-recaptcha" data-sitekey="<?php echo esc_attr($iq_auth_settings_arr['captcha_pub']); ?>"></div>
				</center>
			</div>
			<?php
			die();
		}
		$bCapcha = true;
		$bErr = true;
		return;
	}
	
	$response_key = sanitize_text_field($_POST[$capcha_key]);
	
	$secretKey = $iq_auth_settings_arr['captcha_secret'];
	$ip = $_SERVER['REMOTE_ADDR'];
	$url = 'https://www.google.com/recaptcha/api/siteverify?secret=' . urlencode($secretKey) .  '&response=' . urlencode($response_key);
	$response = file_get_contents($url);
	$responseKeys = json_decode($response,true);
	if(!$responseKeys["success"]) {
		if($AjaxRequest) {
			?>
			<div id="captcha_block" class="iq_auth_align_center">
				<center>
					<script src="https://www.google.com/recaptcha/api.js" async defer></script>
					<div class="g-recaptcha" data-sitekey="<?php echo esc_attr($iq_auth_settings_arr['captcha_pub']); ?>"></div>
				</center>
			</div>
			<?php
			die();
		}
		$bCapcha = true;
		$bErr = true;
		return;
	}
	if($iCaptchaLimitFree) {
		$cIQAuthClass->antifloodRemove($service_lost);
	}
}

if($bCaptcha && !$bCaptchaShow && $iCaptchaLimitFree) {
	$cIQAuthClass->antifloodAdd($service_lost);
}

if( !email_exists($DataValuesArr['iq_email']) ) {
	$szMsg = esc_html__('There is no account for the specified email. Make sure you entered your email correctly', 'registration-and-authorize');
	if($AjaxRequest) {
		die($szMsg);
	}
	$szErr = $szMsg;
	$bErr = true;
	return;
}

######################
##### SEND EMAIL #####
######################


$service = 'lost_code_send';
$code_already = $cIQAuthClass->codeGetAlready($service, $DataValuesArr['iq_email']);

if(!$code_already) {
	// send email
	$iCodeLength = 50;
	$szCode = func_iq_auth_gen_pass($iCodeLength);
	$web_url = ((!empty($_SERVER['HTTPS'])) ? 'https' : 'http') . '://' . esc_html($_SERVER ['SERVER_NAME']);
	
	$restore_url = $web_url.$lost_url.'?email='.$DataValuesArr['iq_email'].'&sign='.$szCode;
	$result = $cIQAuthClass->codeSend($service, $DataValuesArr['iq_email'], $szCode);
	
	$szMsg = esc_html__('To restore your account, follow the link', 'registration-and-authorize').' <a href="{URL}">{URL}</a>';
	$email_message = str_replace("{URL}", $restore_url, $szMsg);

	// send email
	$email = get_option('admin_email');
	$headers = 'Content-Type: text/html\r\n
		From: '. $email . "\r\n" .
		'Reply-To: ' . $email . "\r\n";

	$szTheme = esc_html__('Account recovery', 'registration-and-authorize');
	$result = wp_mail(
		trim($DataValuesArr['iq_email']),
		$szTheme,
		$email_message, 
		$headers
	);
	
	if(!$result) {
		$szMsg = esc_html__('Failed to send account recovery link. Please contact support', 'registration-and-authorize');
		if($AjaxRequest) {
			die($szMsg);
		}
		$szErr = $szMsg;
		$bErr = true;
		
		return;
	}
}

?>

	<div id="lost_answer" class="iq_auth_align_center">
		<div class="iq_auth_li_head">
			<?php if($code_already) { ?>
				<?php echo sprintf(esc_html__('We recently sent an account recovery link to %s. Please check your inbox, check your spam folder, the message may have gone there by mistake', 'registration-and-authorize'), $DataValuesArr['iq_email']); ?>
			<?php } else { ?>
				<?php echo sprintf(esc_html__('A link to restore your account has been sent to email «%s». The message may end up in the Spam folder by mistake, please check this folder and make sure that the letter is not there', 'registration-and-authorize'), $DataValuesArr['iq_email']); ?>
			<?php } ?>
		</div>
	</div>
	
<?php
if($AjaxRequest) {
	die();
}
return;
?>