<?php
if(!isset($_SERVER['HTTP_REFERER'])) { die(); }

$iPostItemID = 0;
if(isset($_POST['ItemID'])) {
	$iPostItemID = (int)sanitize_text_field($_POST['ItemID']);
}
##################
##### ACCESS #####
##################
if ( !is_user_logged_in() ) {
	$szMsg = esc_html__('Authorization required', 'registration-and-authorize');
	die($szMsg);
}

$cur_user_id = get_current_user_id();
if($cur_user_id <= 0) {
	$szMsg = esc_html__('Authorization required', 'registration-and-authorize');
	die($szMsg);
}
$user_obj = get_userdata( $cur_user_id );

if(!$user_obj) {
	wp_logout();
	$szMsg = esc_html__('Authorization required', 'registration-and-authorize');
	die($szMsg);
}
$roles_arr = (array)$user_obj->roles;

$need_role = 'administrator';
if(!in_array($need_role, $roles_arr)) {
	$szMsg = esc_html__('Access denied', 'registration-and-authorize');
	die($szMsg);
}

###############
##### POP #####
###############
$bPop = true;
if(isset($_POST['Pop'])) {
	$bPop = (int)sanitize_text_field($_POST['Pop']);
}
if($bPop) {
	$szPreTag = 'pop_';
} else {
	$szPreTag = '';
}

if(!isset($cIQAuthRedirects)) {
	require_once IQ_AUTH_CORE_DIR.'/includes/inc_redirects.php';
	$cIQAuthRedirects = new IQAuthRedirects();
}

if($iPostItemID) {
	$SQL_Search = "
		AND
			a.`id` = '".$iPostItemID."'
	";
	$results = $cIQAuthRedirects->getList([], $SQL_Search);
	$ItemInfo = [];
	if($results) {
		foreach($results AS $data) {
			$ItemInfo = $data;
			break;
		}
	}
	if(!$ItemInfo) {
		$iPostItemID = 0;
	}
}

if($iPostItemID) {
	// edit
	$FormVal = [
		'head' => esc_html__('Edit redirect', 'registration-and-authorize'),
		'button' => esc_html__('Save', 'registration-and-authorize'),
		'page' => $ItemInfo['page'],
		'type' => $ItemInfo['type'],
		'created' => $ItemInfo['created'],
		'enable_check' => '',
	];
	if($ItemInfo['enable']) {
		$FormVal['enable_check'] = 'checked';
	}
} else {
	// create
	$FormVal = [
		'head' => esc_html__('Add redirect', 'registration-and-authorize'),
		'button' => esc_html__('Add', 'registration-and-authorize'),
		'page' => '',
		'type' => 0,
		'created' => '',
		'enable_check' => 'checked',
	];
}

$iq_redirects_types = $cIQAuthRedirects->getTypes();

$CArr = [
	'pop' => (int)$bPop,
	'item_id' => $iPostItemID,
];
$JsonData = json_encode($CArr);
$JsonDataP = func_iq_auth_in_protect($JsonData);
$SignData = func_iq_auth_get_sign_json_array_protect($JsonDataP);

$iMaxWidth = 700;
?>
<div id="pop">
	<input type="hidden" id="<?php echo esc_html($szPreTag . 'json_data'); ?>" value="<?php echo esc_html($JsonDataP); ?>">
	<input type="hidden" id="<?php echo esc_html($szPreTag . 'sign_data'); ?>" value="<?php echo esc_html($SignData); ?>">
	
	<div class="pop_overlay"></div>
	<div class="pop_modal pop_effect" id="pop_modal">
		<div class="pop_window">
			<div id="pop_pos" class="pop_pos">
				<div id="pop_window" class="pop_main" style="max-width:<?php echo esc_html($iMaxWidth); ?>px;">
					<div class="pop_head">
						<div class="pop_head_txt">
							<?php echo esc_html($FormVal['head']); ?>
						</div>	
						<button class="pop_close_button" onclick="PopClose();" data-content="<?php echo esc_html__('Close', 'registration-and-authorize'); ?>">
							<span class="dashicons dashicons-no"></span>
						</button>
					</div>
					<div id="pop_content" class="pop_body">
						<?php
						// echo '<pre>' . print_r($ItemInfo, true) . '</pre>';
						?>
						<ul id="<?php echo esc_html($szPreTag . 'form_data'); ?>" class="pop_ul">
							
							<!-- page -->
							<li class="iq_auth_li">
								<div class="iq_auth_li_head">
									<?php echo esc_html__('Page URL', 'registration-and-authorize'); ?>
								</div>
								<input type="text" id="<?php echo esc_html($szPreTag . 'page'); ?>" name="<?php echo esc_html($szPreTag . 'page'); ?>" class="iq_auth_input iq_auth_input_default iq_auth_full_width_b" maxlength="64" placeholder="/wp-login" value="<?php echo esc_html($FormVal['page']); ?>">
								<div class="iq_auth_li_about">
									<?php echo esc_html__('Enter the URL of the page from which to redirect', 'registration-and-authorize'); ?>
								</div>
							</li>
							
							<!-- types -->
							<li class="iq_auth_li">
								<div class="iq_auth_li_head">
									<?php echo esc_html__('Redirect to', 'registration-and-authorize'); ?>
								</div>
								<?php if(empty($iq_redirects_types)) { ?>
									<div class="iq_auth_alert_block iq_auth_err">
										<?php echo esc_html__('No matching pages found', 'registration-and-authorize'); ?>
									</div>
								<?php } else { ?>
									<select id="<?php echo esc_html($szPreTag . 'type'); ?>" class="iq_auth_select iq_auth_select_default">
										<option value="0">
											- <?php echo esc_html__('Select page', 'registration-and-authorize'); ?> -
										</option>
										<?php
										foreach($iq_redirects_types AS $data) {
											if($FormVal['type'] == (int)$data['id']) {
												$szDef = 'selected';
											} else {
												$szDef = '';
											}
											?>
											<option value="<?php echo esc_html($data['id']); ?>" <?php echo esc_html($szDef); ?>>
												<?php echo esc_html__($data['name'], 'registration-and-authorize'); ?>
											</option>
											<?php
										}
										?>
									</select>
								<?php } ?>
							</li>
	
							<!-- enable -->
							<li class="iq_auth_li">
								<div class="iq_auth_li_head">
									<?php echo esc_html__('Enabled redirect', 'registration-and-authorize'); ?>?
								</div>
								<input class="iq_auth_tgl iq_auth_tgl_ios" id="<?php echo esc_html($szPreTag . 'enable'); ?>" name="<?php echo esc_html($szPreTag . 'enable'); ?>" type="checkbox" <?php echo esc_html($FormVal['enable_check']); ?>>
								<label class="iq_auth_tgl_btn" for="<?php echo esc_html($szPreTag . 'enable'); ?>"></label>
							</li>
	
							<!-- red_notice_block -->
							<li class="iq_auth_li">
								<div id="<?php echo esc_html($szPreTag . 'red_notice_block'); ?>"></div>
							</li>
	
							<!-- buttons -->
							<li class="pop_li iq_auth_center">
								<button class="iq_auth_button_light_green iq_auth_button_margin" onclick="IQAuthRedirectsAddDo(<?php echo esc_html($bPop); ?>, <?php echo esc_html($iPostItemID); ?>); return false;">
									<?php echo esc_html($FormVal['button']); ?>
								</button>
							</li>
						</ul>
						
						<!-- Copyright -->
						<div class="iq_auth_copyright_block">
							<?php
							$copyright_url = 'https://lumpx.com/wp-plugins';
							?>
							<a href="<?php echo esc_url($copyright_url); ?>" target="_blank" class="iq_auth_copyright_a">Developed by LumpX</a>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>