<?php
// Restrict
if(!defined('ABSPATH') || !defined('IQ_AUTH_CORE_DIR')) {
	die();
}
require_once dirname( __FILE__ ).'/inc_menu.php';
require_once dirname( __FILE__ ).'/inc_protect.php';

function func_iq_auth_get_count_notification() {
	return 0;
}

function func_iq_auth_get_settings() {
	if(IQ_AUTH_CACHE_SETTINGS_FILE) {
		$FILE = IQ_AUTH_CORE_DIR.'/cache/.'.IQ_AUTH_CACHE_SETTINGS_FILE;
		if(file_exists($FILE)) {
			$json_p = file_get_contents($FILE);
			if($json_p) {
				$result = json_decode(func_iq_auth_out_protect($json_p), true);
				if($result) {
					return $result;
				}
			}
		}
	}
	
    global $wpdb;
    $sql = "
		SELECT
			`params_json`
		FROM
			`{$wpdb->prefix}iq_auth_settings`
		WHERE
			`key` = 'settings';
	";
    $result = $wpdb->get_row($wpdb->prepare($sql), ARRAY_A);
    if($result) {
        $result = (array)$result;
        $result = json_decode($result['params_json'], true);
    }
		
	if(IQ_AUTH_CACHE_SETTINGS_FILE) {
		$FILE = IQ_AUTH_CORE_DIR.'/cache/.'.IQ_AUTH_CACHE_SETTINGS_FILE;
		file_put_contents($FILE, func_iq_auth_in_protect(json_encode($result)));
	}
    return $result;
}

/**
 * Update settings plugin database
 * @since 1.0.0
 * @return boolean
 */
function func_iq_auth_updateSettings($arr) {
    global $wpdb;
    $sql = "
		UPDATE
			`{$wpdb->prefix}iq_auth_settings`
		SET
			`params_json` = %s
		WHERE
			`key` = 'settings'
	";
    $wpdb->query($wpdb->prepare($sql, json_encode($arr)));
	
	if(IQ_AUTH_CACHE_SETTINGS_FILE) {
		$FILE = IQ_AUTH_CORE_DIR.'/cache/.'.IQ_AUTH_CACHE_SETTINGS_FILE;
		file_put_contents($FILE, func_iq_auth_in_protect(json_encode($arr)));
	}
    return true;
}

function func_iq_auth_get_sign_json_array_protect($json_arr, $secret = IQ_AUTH_SECRET_CODE) {
	$params1 = [
		'json' => $json_arr,
		'sole' => 'jeo4ZQBOeOxmOqXwk7nDK8RF8OscdJhj',
		'code' => $secret,
	];	
	$hash1 = hash('sha256', join('{sign1_protect}', $params1));
	$hash2 = md5($json_arr . $secret . $hash1);
	$params3 = [
		'json' => $json_arr,
		'sole' => 'DQIcnrHTRGqdzdw1QI0VcnAp7xa91Qlt',
		'sole2' => 'RNyyoRBbKPx6ThDbYyQJyG1r7THCq52Q',
	];	
	$hash3 = hash('sha256', join('{sign2_protect}', $params3));
	$hash4 = md5($json_arr . $secret . $hash3);
	$hash = $hash1.'-'.$hash2.'-'.$hash3.'-'.$hash4;
	return $hash;
}

function func_iq_auth_get_count_letter($string) {
	$string = str_replace( "\r\n","\n", $string );
	return mb_strlen($string);
}

function func_iq_auth_gen_num($length = 4) {
	$chars = '1234567890';
	$iNumChars = strlen($chars);
	$string = '';
	for ($i = 0; $i < $length; $i++) {
		$string .= substr($chars, rand(1, $iNumChars) - 1, 1);
	}
	return $string;
}

function func_iq_auth_gen_pass($length = 8, $symb = false) {
	$chars = 'abdefhiknrstyzABDEFGHKNQRSTYZ23456789';
	if($symb) {
		$chars .= '!@#$%^*()-+=';
	}
	$iNumChars = strlen($chars);
	$string = '';
	for ($i = 0; $i < $length; $i++) {
		$string .= substr($chars, rand(1, $iNumChars) - 1, 1);
	}
	return $string;
}

function func_iq_auth_outdb($str) {
	$str = trim(func_iq_auth_replace_quotes(stripslashes(sanitize_text_field($str))));
	return $str;
}

function func_iq_auth_in($str) {
	$str = trim(func_iq_auth_replace_quotes(sanitize_text_field($str)));
	return $str;
}

function func_iq_auth_replace_quotes($text) {
	$text = htmlspecialchars_decode($text, ENT_QUOTES);
	$text = str_replace(array('«', '»'), '"', $text);
	return preg_replace_callback('/(([\"]{2,})|(?![^\W])(\"))|([^\s][\"]+(?![\w]))/u', 'func_iq_auth_replace_quotes_callback', $text);
}

function func_iq_auth_replace_quotes_callback($matches) {
	if (count($matches) == 3) {
		return '«»';
	} elseif (!empty($matches[1])) {
		return str_replace('"', '«', $matches[1]);
	} else { 
		return str_replace('"', '»', $matches[4]);
	}
}
function func_iq_auth_only_numbers($s) {
	$s = preg_replace( "/[^0-9\s]/", '', $s );
    return (int)$s;
}
function func_iq_auth_module_enable($name) {
	if(file_exists(IQ_AUTH_CORE_DIR.'/modules/'.$name.'/'.$name.'.php')) {
		return true;
	}
	return false;
}


function func_iq_auth_get_modules() {
	$arr = [];
	$dir = opendir(IQ_AUTH_CORE_DIR.'/modules');
	while($file = readdir($dir)) {
	   if (is_dir(IQ_AUTH_CORE_DIR.'/modules/'.$file) && $file != '.' && $file != '..') {
		   $arr[] = trim($file);
	   }
	}
	return $arr;
}

