<?php
// Restrict
if(!defined('ABSPATH') || !defined('IQ_AUTH_CORE_DIR')) {
	die();
}

function iq_auth_pre_create_menu() {
	$notification_count = func_iq_auth_get_count_notification(-1);
	iq_auth_create_menu($notification_count);
}
function iq_auth_create_menu($notification_count) {
	add_menu_page(
		'IQ Authorization',
		$notification_count ? sprintf('%s <span class="awaiting-mod">%d</span>', 'IQ Authorization', $notification_count) : 'IQ Authorization',
		'manage_options',
		IQ_AUTH_MENU_TAG.'index',
		'iq_auth_menu_core_callback',
		'dashicons-buddicons-buddypress-logo',
		50 );

	add_submenu_page(
		IQ_AUTH_MENU_TAG.'index',
		esc_html__('Settings', 'registration-and-authorize'),
		esc_html__('Settings', 'registration-and-authorize'),
		'manage_options',
		IQ_AUTH_MENU_TAG.'settings-page',
		'iq_auth_menu_settings_callback',
		1
	);

	add_submenu_page(
		IQ_AUTH_MENU_TAG.'index',
		esc_html__('Authorization', 'registration-and-authorize'),
		esc_html__('Authorization', 'registration-and-authorize'),
		'manage_options',
		IQ_AUTH_MENU_TAG.'login-page',
		'iq_auth_menu_auth_callback',
		2
	);

	add_submenu_page(
		IQ_AUTH_MENU_TAG.'index',
		esc_html__('Registration', 'registration-and-authorize'),
		esc_html__('Registration', 'registration-and-authorize'),
		'manage_options',
		IQ_AUTH_MENU_TAG.'regist-page',
		'iq_auth_menu_regist_callback',
		3
	);

	add_submenu_page(
		IQ_AUTH_MENU_TAG.'index',
		esc_html__('Lost page', 'registration-and-authorize'),
		esc_html__('Lost page', 'registration-and-authorize'),
		'manage_options',
		IQ_AUTH_MENU_TAG.'lost-page',
		'iq_auth_menu_lost_callback',
		4
	);

	add_submenu_page(
		IQ_AUTH_MENU_TAG.'index',
		esc_html__('Redirects', 'registration-and-authorize'),
		esc_html__('Redirects', 'registration-and-authorize'),
		'manage_options',
		IQ_AUTH_MENU_TAG.'redirect-page',
		'iq_auth_menu_redirect_callback',
		5
	);

	if(func_iq_auth_module_enable('custom_fields')) {
		add_submenu_page(
			IQ_AUTH_MENU_TAG.'index',
			esc_html__('Custom fields', 'registration-and-authorize'),
			esc_html__('Custom fields', 'registration-and-authorize'),
			'manage_options',
			IQ_AUTH_MENU_TAG.'custom-fields-page',
			'iq_auth_menu_custom_fields_callback',
			6
		);
	} else {
		if(!IQ_AUTH_PRO_VERSION) {
			add_submenu_page(
				IQ_AUTH_MENU_TAG.'index',
				esc_html__('Custom fields', 'registration-and-authorize'),
				esc_html__('Custom fields', 'registration-and-authorize'),
				'manage_options',
				IQ_AUTH_MENU_TAG.'custom-fields-page',
				'iq_auth_go_pro_redirect',
				6
			);
		}
	}

	// WIZARD
	add_submenu_page(
		IQ_AUTH_MENU_TAG.'index',
		esc_html__('Wizard', 'registration-and-authorize'),
		esc_html__('Wizard', 'registration-and-authorize'),
		'manage_options',
		IQ_AUTH_MENU_TAG.'wizard',
		'iq_auth_menu_wizard_callback',
		7
	);

	add_submenu_page(
		IQ_AUTH_MENU_TAG.'index',
		esc_html__('Plugins', 'registration-and-authorize'),
		'<span style="color:#81bfdd;"><span class="dashicons dashicons-image-filter" style="font-size: 17px"></span> ' . __('Plugins', 'registration-and-authorize') . '</span>',
		'manage_options',
		IQ_AUTH_MENU_TAG.'other-plugins',
		'iq_auth_go_plugins_redirect'
	);

	if(!IQ_AUTH_PRO_VERSION) {
		add_submenu_page(
			IQ_AUTH_MENU_TAG.'index',
			'',
			'<span style="color:#f5a30d;"><span class="dashicons dashicons-star-filled" style="font-size: 17px"></span> Go Pro</span>',
			'manage_options',
			IQ_AUTH_MENU_TAG.'pro',
			'iq_auth_go_pro_redirect'
		);
	} else {
		add_submenu_page(
			IQ_AUTH_MENU_TAG.'index',
			esc_html__('Support', 'registration-and-authorize'),
			'<span style="color:#81bfdd;"><i class="icofont-life-buoy" style="font-size: 18px"></i> ' . __('Support', 'registration-and-authorize') . '</span>',
			'manage_options',
			IQ_AUTH_MENU_TAG.'support',
			'iq_auth_go_support_redirect'
		);
		
		add_submenu_page(
			IQ_AUTH_MENU_TAG.'index',
			esc_html__('License', 'registration-and-authorize'),
			'<span style="color:#ddd716;"><i class="icofont-key" style="font-size: 18px"></i> ' . __('License', 'registration-and-authorize') . '</span>',
			'manage_options',
			IQ_AUTH_MENU_TAG.'license',
			'iq_auth_go_license_redirect'
		);
	}
}

function iq_auth_menu_core_callback() {
	include IQ_AUTH_CORE_DIR . '/templates/iq_auth_index.php';
}
function iq_auth_menu_settings_callback() {
	include IQ_AUTH_CORE_DIR . '/templates/iq_auth_settings.php';
}
function iq_auth_menu_auth_callback() {
	include IQ_AUTH_CORE_DIR . '/templates/iq_auth_login_page.php';
}
function iq_auth_menu_regist_callback() {
	include IQ_AUTH_CORE_DIR . '/templates/iq_auth_regist_page.php';
}
function iq_auth_menu_lost_callback() {
	include IQ_AUTH_CORE_DIR . '/templates/iq_auth_lost_page.php';
}
function iq_auth_menu_redirect_callback() {
	include IQ_AUTH_CORE_DIR . '/templates/iq_auth_redirect_page.php';
}
function iq_auth_menu_custom_fields_callback() {
	if(func_iq_auth_module_enable('custom_fields')) {
		include IQ_AUTH_CUSTOM_FIELDS_DIR . '/templates/iq_auth_custom_fields_page.php';
	}
}
function iq_auth_go_plugins_redirect() {
	if ( isset( $_GET['page'] ) && IQ_AUTH_MENU_TAG.'other-plugins' === sanitize_text_field($_GET['page']) ) {
		wp_redirect( 'https://lumpx.com/wp-plugins' );
		die;
	}
}
function IQ_AUTH_go_support_redirect() {
	if ( isset( $_GET['page'] ) && IQ_AUTH_MENU_TAG.'support' === sanitize_text_field($_GET['page']) ) {
		wp_redirect( 'https://lumpx.com/en/support/open' );
		die;
	}
}
function IQ_AUTH_go_license_redirect() {
	if ( isset( $_GET['page'] ) && IQ_AUTH_MENU_TAG.'license' === sanitize_text_field($_GET['page']) ) {
		wp_redirect( 'https://lumpx.com/en/wp-plugins/license' );
		die;
	}
}

function iq_auth_go_pro_redirect() {
	include IQ_AUTH_CORE_DIR . '/templates/iq_auth_window_pro.php';
}

/*
###################
###### WIZARD #####
###################
*/
function iq_auth_menu_wizard_callback() {
	include IQ_AUTH_CORE_DIR . '/wizard/iq_authorize_wizard.php';
}
function iq_auth_wp_admin_submenu_filter( $submenu_file ) {
    global $plugin_page;
    $hidden_submenus = array(
        IQ_AUTH_MENU_TAG.'wizard' => true,
    );
    if ( $plugin_page && isset( $hidden_submenus[ $plugin_page ] ) ) {
        $submenu_file = 'submenu_to_highlight';
    }
    foreach ( $hidden_submenus as $submenu => $unused ) {
        remove_submenu_page( IQ_AUTH_MENU_TAG.'index', $submenu );
    }
    return $submenu_file;
}
add_filter( 'submenu_file', 'iq_auth_wp_admin_submenu_filter' );