<?php
// Restrict
if(!defined('ABSPATH') || !defined('IQ_AUTH_CORE_DIR')) {
	die();
}

define('iq_auth_CACHE_REDIRECT_FILE', 'iq-redirects' );
define('iq_auth_CACHE_REDIRECT_LINES', 'iq-redirects' );
class IQAuthRedirects {
	/*
	if(!isset($cIQAuthRedirects)) {
		require_once IQ_AUTH_CORE_DIR.'/includes/inc_redirects.php';
		$cIQAuthRedirects = new IQAuthRedirects();
	}
	*/
	
	/**
	 * Create plugin database
	 * @since 1.0.0
	 * @return boolean
	 */
	function createDB() {
		global $wpdb;
		
		// redirects
        $sql = "
			CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}iq_auth_redirects` (
					`id` int(20) NOT NULL AUTO_INCREMENT,
					`page` varchar(100) NOT NULL DEFAULT '',
					`type` int(5) NOT NULL DEFAULT 0,
					`created` int(11) NOT NULL DEFAULT 0,
					`enable` tinyint(2) NOT NULL DEFAULT 1,
					PRIMARY KEY `id` (`id`)
			);
        ";
		$index = $wpdb->query($wpdb->prepare($sql));
		
		// redirects
        $sql = "
			CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}iq_auth_redirects_types` (
					`id` int(20) NOT NULL DEFAULT 0,
					`name` varchar(100) NOT NULL DEFAULT '',
					PRIMARY KEY `id` (`id`)
			);
        ";
		$index = $wpdb->query($wpdb->prepare($sql));
		if($index) {
			$sql = "
				INSERT INTO `{$wpdb->prefix}iq_auth_redirects_types` VALUES (1, 'Login page');
			";
			$wpdb->query($wpdb->prepare($sql));
			$sql = "
				INSERT INTO `{$wpdb->prefix}iq_auth_redirects_types` VALUES (2, 'Registration page');
			";
			$wpdb->query($wpdb->prepare($sql));
			$sql = "
				INSERT INTO `{$wpdb->prefix}iq_auth_redirects_types` VALUES (3, 'Lost page');
			";
			$wpdb->query($wpdb->prepare($sql));
		}
		return true;
	}
	
	/**
	 * Remove plugin database
	 * @since 1.0.0
	 * @return boolean
	 */
	function removeDB() {
		global $wpdb;
		
		// redirects
        $sql = "
			DROP TABLE `{$wpdb->prefix}iq_auth_redirects`
        ";
		$index = $wpdb->query($wpdb->prepare($sql));
		
		// redirects
        $sql = "
			DROP TABLE `{$wpdb->prefix}iq_auth_redirects_types`
        ";
		$index = $wpdb->query($wpdb->prepare($sql));
		return true;
	}
	
	/**
	 * Get redirects
	 * @since 1.0.0
	 * @return array
	 */
	function getTypes() {
		global $wpdb;
		$sql = "
			SELECT
				*
			FROM
				`{$wpdb->prefix}iq_auth_redirects_types`;
		";
		$result = $wpdb->get_results($wpdb->prepare($sql), ARRAY_A);
		return $result;
	}
	
	/**
	 * Getting a list of IQ Users
	 * @param array $args Args list
	 * @since 1.0.0
	 * @return array
	 */
	function getList($args = [], $search = '', $filters = []) {
        $sql_search = '';
        $sql_limit = '';
		if($search) {
			$sql_search .= "
                {$search}
            ";
		}
		
	    if($args) {
            $sql_limit .= "
                LIMIT 
                    {$args['offset']}, {$args['number']}
            ";
        }
		
        $sql_order = "
			ORDER BY
				a.`id` ASC
		";
		
		if($filters) {
			foreach($filters AS $name => $order) {
				$sql_order = "
					ORDER BY
						a.`".$name."` ".$order."
				";
			}
		}
		
		global $wpdb;
		$sql = "
			SELECT
				a.*,
				b.`name` AS `type_name`
			FROM
				`{$wpdb->prefix}iq_auth_redirects` a
			INNER JOIN
				`{$wpdb->prefix}iq_auth_redirects_types` b
			ON
				a.`type` = b.`id`
			WHERE
				a.`id` > 0
				{$sql_search}
				{$sql_order}
				{$sql_limit}
		";
		// echo '<pre>' . print_r($sql, true) . '</pre>';

		$results = $wpdb->get_results(
			$wpdb->prepare($sql),
			ARRAY_A
		);
		
		$results_arr = [];
		if($results) {
			$iNum = 0;
			foreach($results AS $key => $data) {
				$iNum++;
				$results_arr[$key] = $data;
				$results_arr[$key]['num'] = $iNum;
			}
		}
		return $results_arr;
	}
	
	/**
	 * Get settings redirects
	 * @since 1.0.0
	 * @return array
	 */
	function get() {
		if(iq_auth_CACHE_REDIRECT_FILE) {
			$FILE = IQ_AUTH_CORE_DIR.'/cache/.'.iq_auth_CACHE_REDIRECT_FILE;
			if(file_exists($FILE)) {
				$json_p = file_get_contents($FILE);
				if($json_p) {
					$result = json_decode(func_iq_auth_out_protect($json_p), true);
					if($result) {
						return $result;
					}
				}
			}
		}
	
		global $wpdb;
		$result_arr = [];
		$sql = "
			SELECT
				a.`page`,
				a.`type`
			FROM
				`{$wpdb->prefix}iq_auth_redirects` a
			WHERE
				a.`enable` = 1
		";
		$result = $wpdb->get_results($wpdb->prepare($sql), ARRAY_A);
		if($result) {
			foreach($result AS $data) {
				$result_arr[] = [
					'page' => $data['page'],
					'type' => (int)$data['type']
				];
			}
		}
			
		if(iq_auth_CACHE_REDIRECT_FILE) {
			$FILE = IQ_AUTH_CORE_DIR.'/cache/.'.iq_auth_CACHE_REDIRECT_FILE;
			file_put_contents($FILE, func_iq_auth_in_protect(json_encode($result_arr)));
		}
		return $result_arr;
	}
	
	/**
	 * Update settings redirect
	 * @since 1.0.0
	 * @return array
	 */
	function add($arr, $item_id = 0) {
		global $wpdb;
		
		$iCurrentTime = time();
		if($item_id) {
			// edit
			$sql = "
				UPDATE 
					`{$wpdb->prefix}iq_auth_redirects`
				SET
					`page` = %s,
					`type` = %d,
					`created` = %d,
					`enable` = %d
				WHERE
					`id` = %d
			";
			$index = $wpdb->query($wpdb->prepare($sql, 
										$arr['page'],
										$arr['type'],
										$iCurrentTime,
										$arr['enable'],
										$item_id
										)
								 );
		} else {
			// create
			$sql = "
				INSERT INTO `{$wpdb->prefix}iq_auth_redirects`
					(`page`,
					`type`,
					`created`,
					`enable`)
				VALUES
					(%s,
					'%d',
					'%d',
					'%d');
			";
			$index = $wpdb->query($wpdb->prepare($sql, 
										$arr['page'],
										$arr['type'],
										$iCurrentTime,
										$arr['enable']
										)
								 );
		}
		if($index) {
			if(iq_auth_CACHE_REDIRECT_FILE) {
				$FILE = IQ_AUTH_CORE_DIR.'/cache/.'.iq_auth_CACHE_REDIRECT_FILE;
				if(file_exists($FILE)) {
					unlink($FILE);
				}
			}
			return true;
		}
		return false;
	}
	
	function remove($item_id) {
		global $wpdb;
		$sql = "
			DELETE FROM
				`{$wpdb->prefix}iq_auth_redirects`
			WHERE
				`id` = %d;
		";
		$index = $wpdb->query($wpdb->prepare($sql, $item_id));
		if($index) {
			if(iq_auth_CACHE_REDIRECT_FILE) {
				$FILE = IQ_AUTH_CORE_DIR.'/cache/.'.iq_auth_CACHE_REDIRECT_FILE;
				if(file_exists($FILE)) {
					unlink($FILE);
				}
			}
		
			return true;
		}
		return false;
	}
}