<?php
// Restrict
if(!defined('ABSPATH') || !defined('IQ_AUTH_CORE_DIR')) {
	die();
}

if (!function_exists('is_plugin_active')) {
	include_once(ABSPATH . 'wp-admin/includes/plugin.php');
}

if(!isset($cIQAuthClass)) {
	require_once IQ_AUTH_CORE_DIR.'/includes/inc_auth.php';
	$cIQAuthClass = new IQAuthClass();
}

$number = 15;

$paged = 1;
if(isset($_GET['paged']) && (int)sanitize_text_field($_GET['paged'])) {
    $paged = (int)sanitize_text_field($_GET['paged']);
}

$filterArr = [];

$offset = ($paged - 1) * $number;
$users = $cIQAuthClass->getUsers([], '', $filterArr);
$total_users = count($users);
$args = [
    'offset' =>  $offset,
    'number' =>  $number,
];
$query = $cIQAuthClass->getUsers($args, '', $filterArr);
$total_users = count($users);
$total_query = count($query);
$total_pages = intval($total_users / $number) + 1;

$iCollumsCount = 0;

$cf_collums = [];
if(func_iq_auth_module_enable('custom_fields')) {
	include IQ_AUTH_CUSTOM_FIELDS_DIR.'/views/views_users.php';
}
?>
<div class="iq_auth_core_block">
    <div class="iq_auth_list_block iq_auth_hided">
        <h2 class="iq_auth_head_block">
            <?php echo esc_html__('IQ Users', 'registration-and-authorize'); ?>
        </h2>
		
		<table class="iq_auth_tbl">
			<div id="notice_block"></div>
			<thead>
			<tr>
				<th scope="col">
					<?php echo esc_html__('Login', 'registration-and-authorize'); ?>
					<?php $iCollumsCount++ ?>
				</th>
				<?php
				// show custom fields
				if($cf_collums) {
					foreach($cf_collums AS $cf_key => $cf_name_collum) {
						?>
						<th scope="col">
							<?php echo $cf_name_collum; ?>
							<?php $iCollumsCount++ ?>
						</th>
						<?php
					}
				}
				?>
				<th scope="col">
					<?php echo esc_html__('Added', 'registration-and-authorize'); ?>
					<?php $iCollumsCount++ ?>
				</th>
				<th scope="col">
					<?php echo esc_html__('Action', 'registration-and-authorize'); ?>
					<?php $iCollumsCount++ ?>
				</th>
			</tr>
			</thead>
			<tbody>
				<?php
				if(!$query) {
					?>
					<tr>
						<td colspan="<?php echo esc_html($iCollumsCount); ?>">
							<?php
							if($paged <= 1) {
								?>
								<div class="iq_auth_nf_block">
									<div class="iq_auth_nf_icon">
										<i class="icofont-users-social"></i>
									</div>
									<div class="iq_auth_nf_head">
										<?php echo esc_html__('IQ users not found', 'registration-and-authorize'); ?>
									</div>
									<div class="iq_auth_nf_txt iq_auth_block_centered">
										<?php echo esc_html__('You can import existing users. To do this, use the Setup Wizard', 'registration-and-authorize'); ?>
									</div>
								</div>
								<?php
							}
							?>
						</td>
					</tr>
					<?php
				} else {
					foreach($query AS $q) {
						include IQ_AUTH_CORE_DIR.'/data/data_user_reload.php';
					}
				}
				?>
			</tbody>
		</table>
		
		<!-- Copyright -->
		<div class="iq_auth_copyright_block">
			<?php
			$copyright_url = 'https://lumpx.com/wp-plugins';
			?>
			<a href="<?php echo esc_url($copyright_url); ?>" target="_blank" class="iq_auth_copyright_a">Developed by LumpX</a>
		</div>
	</div>
</div>