<?php
// Restrict
if(!defined('ABSPATH') || !defined('IQ_AUTH_CORE_DIR')) {
	die();
}

$iq_auth_settings_arr = func_iq_auth_get_settings();
?>
<div class="iq_auth_core_block">
    <div class="iq_auth_list_block iq_auth_hided">
        <h2 class="iq_auth_head_block">
            <?php echo esc_html__('Login page', 'iq_auth_system'); ?>
        </h2>
		
		<?php
		################
		##### POST #####
		################
		$bErr = false;
		$szMsg = '';
		if(isset($_POST['form_save'])) {
			// login_title
			$iq_auth_settings_arr['login_title'] = '';
			if(isset($_POST['login_title'])) {
				$iq_auth_settings_arr['login_title'] = sanitize_text_field($_POST['login_title']);
			}
			
			// login_url
			$iq_auth_settings_arr['login_url'] = IQ_AUTH_AUTH_PAGE_DEF;
			if(isset($_POST['login_url'])) {
				$login_url = sanitize_text_field($_POST['login_url']);
				if($login_url != $iq_auth_settings_arr['login_url']) {
					$iq_auth_settings_arr['login_url'] = $login_url;
				}
			}
			
			// login_captcha_enable
			$iq_auth_settings_arr['login_captcha_enable'] = false;
			if(isset($_POST['login_captcha_enable']) && $_POST['login_captcha_enable'] == 'on') {
				$iq_auth_settings_arr['login_captcha_enable'] = true;
			}
			
			$bSave = func_iq_auth_updateSettings($iq_auth_settings_arr);
			if(!$bSave) {
				$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
				$bErr = true;
			}
			
			if($bErr) {
				if(empty($szMsg)) {
					$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
				}
			} else {
				$szMsg = esc_html__('Settings have been saved', 'registration-and-authorize');
			}
			
			if($bErr) {
				?>
				
				<div class="iq_auth_alert_block iq_auth_err">
					<?php echo esc_html($szMsg); ?>
				</div>
					
				<?php
			} else {
				?>
				
				<div class="iq_auth_alert_block iq_auth_ok">
					<?php echo esc_html($szMsg); ?>
				</div>
				
				<?php
			}
		}
		?>
		
		<div class="iq_auth_alert_block iq_auth_info">
			<?php echo esc_html__('In this section, you can configure the authorization page', 'registration-and-authorize'); ?>
		</div>
		
		<?php
		$FormVal = [
			'login_title' => '',
			'login_url' => IQ_AUTH_AUTH_PAGE_DEF,
			'login_captcha_enable' => '',
		];
		if(isset($iq_auth_settings_arr['login_title'])) {
			$FormVal['login_title'] = $iq_auth_settings_arr['login_title'];
		}
		if(isset($iq_auth_settings_arr['login_url'])) {
			$FormVal['login_url'] = $iq_auth_settings_arr['login_url'];
		}
		if(isset($iq_auth_settings_arr['login_captcha_enable']) && (int)$iq_auth_settings_arr['login_captcha_enable']) {
			$FormVal['login_captcha_enable'] = 'checked';
		}
		?>

		<form method="POST">
			<input type="hidden" name="form_save" value="1">
			<ul class="iq_auth_ulcl">
			
				<!-- login_title -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Login page title', 'registration-and-authorize'); ?>
					</div>
					<input type="text" id="login_title" name="login_title" class="iq_auth_input iq_auth_input_default iq_auth_full_width_b iq_auth_max_w500" maxlength="64" placeholder="<?php echo esc_html__('Authorization', 'registration-and-authorize'); ?>" value="<?php echo esc_attr($FormVal['login_title']); ?>">
				</li>
			
				<!-- login_url -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Login page URL', 'registration-and-authorize'); ?>
					</div>
					<input type="text" id="login_url" name="login_url" class="iq_auth_input iq_auth_input_default" maxlength="64" placeholder="" value="<?php echo esc_attr($FormVal['login_url']); ?>">
				</li>
			
				<!-- login_captcha_enable -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Enable/Disable Captcha', 'registration-and-authorize'); ?>
					</div>
					<input class="iq_auth_tgl iq_auth_tgl_ios" id="login_captcha_enable" name="login_captcha_enable" type="checkbox" <?php echo esc_attr($FormVal['login_captcha_enable']); ?>>
					<label class="iq_auth_tgl_btn" for="login_captcha_enable"></label>
				</li>
				
				<button type="submit" class="iq_auth_button_light_blue iq_auth_button_margin">
					<?php echo esc_html__('Save', 'registration-and-authorize'); ?>
				</button>
			</ul>
		</form>
		
		<!-- Copyright -->
		<div class="iq_auth_copyright_block">
			<?php
			$copyright_url = 'https://lumpx.com/wp-plugins';
			?>
			<a href="<?php echo esc_url($copyright_url); ?>" target="_blank" class="iq_auth_copyright_a">Developed by LumpX</a>
		</div>
	</div>
</div>