<?php
// Restrict
if(!defined('ABSPATH') || !defined('IQ_AUTH_CORE_DIR')) {
	die();
}

$iq_auth_settings_arr = func_iq_auth_get_settings();
?>
<div class="iq_auth_core_block">
    <div class="iq_auth_list_block iq_auth_hided">
        <h2 class="iq_auth_head_block">
            <?php echo esc_html__('Registration page', 'iq_auth_system'); ?>
        </h2>
		
		<?php
		################
		##### POST #####
		################
		$bErr = false;
		$szMsg = '';
		if(isset($_POST['form_save'])) {
			// regist_title
			$iq_auth_settings_arr['regist_title'] = '';
			if(isset($_POST['regist_title'])) {
				$iq_auth_settings_arr['regist_title'] = sanitize_text_field($_POST['regist_title']);
			}
			
			// regist_url
			$iq_auth_settings_arr['regist_url'] = IQ_AUTH_REGIST_PAGE_DEF;
			if(isset($_POST['regist_url'])) {
				$regist_url = sanitize_text_field($_POST['regist_url']);
				if($regist_url != $iq_auth_settings_arr['regist_url']) {
					$iq_auth_settings_arr['regist_url'] = $regist_url;
				}
			}
			
			// regist_captcha_enable
			$iq_auth_settings_arr['regist_captcha_enable'] = false;
			if(isset($_POST['regist_captcha_enable']) && $_POST['regist_captcha_enable'] == 'on') {
				$iq_auth_settings_arr['regist_captcha_enable'] = true;
			}
			
			// email_confirm
			$iq_auth_settings_arr['email_confirm'] = false;
			if(isset($_POST['email_confirm']) && $_POST['email_confirm'] == 'on') {
				$iq_auth_settings_arr['email_confirm'] = true;
			}
			
			// email_confirm_length
			$iq_auth_settings_arr['email_confirm_length'] = 6;
			if(isset($_POST['email_confirm_length'])) {
				$iq_auth_settings_arr['email_confirm_length'] = (int)sanitize_text_field($_POST['email_confirm_length']);
			}
			
			// email_confirm_tries_max
			$iq_auth_settings_arr['email_confirm_tries_max'] = 5;
			if(isset($_POST['email_confirm_tries_max'])) {
				$iq_auth_settings_arr['email_confirm_tries_max'] = (int)sanitize_text_field($_POST['email_confirm_tries_max']);
			}
			
			// email_confirm_message
			$iq_auth_settings_arr['email_confirm_message'] = '';
			if(isset($_POST['email_confirm_message'])) {
				$iq_auth_settings_arr['email_confirm_message'] = sanitize_text_field($_POST['email_confirm_message']);
			}
			
			$bSave = func_iq_auth_updateSettings($iq_auth_settings_arr);
			if(!$bSave) {
				$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
				$bErr = true;
			}
			
			if($bErr) {
				if(empty($szMsg)) {
					$szMsg = esc_html__('An error has occurred', 'registration-and-authorize');
				}
			} else {
				$szMsg = esc_html__('Settings have been saved', 'registration-and-authorize');
			}
			
			if($bErr) {
				?>
				
				<div class="iq_auth_alert_block iq_auth_err">
					<?php echo esc_html($szMsg); ?>
				</div>
					
				<?php
			} else {
				?>
				
				<div class="iq_auth_alert_block iq_auth_ok">
					<?php echo esc_html($szMsg); ?>
				</div>
				
				<?php
			}
		}
		?>
		
		<div class="iq_auth_alert_block iq_auth_info">
			<?php echo esc_html__('In this section, you can configure the registration page', 'registration-and-authorize'); ?>
		</div>
		
		<?php
		$FormVal = [
			'regist_title' => '',
			'regist_url' => IQ_AUTH_REGIST_PAGE_DEF,
			'regist_captcha_enable' => '',
			'email_confirm' => '',
			'email_confirm_message' => esc_html__('Hello! Your account verification code: {CODE}. Enter it in the input field on the registration page', 'registration-and-authorize'),
			'email_confirm_length' => 6,
			'email_confirm_tries_max' => 5,
		];
		if(isset($iq_auth_settings_arr['regist_title'])) {
			$FormVal['regist_title'] = $iq_auth_settings_arr['regist_title'];
		}
		if(isset($iq_auth_settings_arr['regist_url'])) {
			$FormVal['regist_url'] = $iq_auth_settings_arr['regist_url'];
		}
		if(isset($iq_auth_settings_arr['regist_captcha_enable']) && (int)$iq_auth_settings_arr['regist_captcha_enable']) {
			$FormVal['regist_captcha_enable'] = 'checked';
		}
		if(isset($iq_auth_settings_arr['email_confirm']) && (int)$iq_auth_settings_arr['email_confirm']) {
			$FormVal['email_confirm'] = 'checked';
		}
		if(isset($iq_auth_settings_arr['email_confirm_length'])) {
			$FormVal['email_confirm_length'] = (int)$iq_auth_settings_arr['email_confirm_length'];
		}
		if(isset($iq_auth_settings_arr['email_confirm_tries_max'])) {
			$FormVal['email_confirm_tries_max'] = (int)$iq_auth_settings_arr['email_confirm_tries_max'];
		}
		if(isset($iq_auth_settings_arr['email_confirm_message'])) {
			$FormVal['email_confirm_message'] = $iq_auth_settings_arr['email_confirm_message'];
		}
		?>

		<form method="POST">
			<input type="hidden" name="form_save" value="1">
			<ul class="iq_auth_ulcl">
			
				<!-- regist_title -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Registration page title', 'registration-and-authorize'); ?>
					</div>
					<input type="text" id="regist_title" name="regist_title" class="iq_auth_input iq_auth_input_default iq_auth_full_width_b iq_auth_max_w500" maxlength="64" placeholder="<?php echo esc_html__('Registration', 'registration-and-authorize'); ?>" value="<?php echo esc_attr($FormVal['regist_title']); ?>">
				</li>
			
				<!-- regist_url -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Registration page URL', 'registration-and-authorize'); ?>
					</div>
					<input type="text" id="regist_url" name="regist_url" class="iq_auth_input iq_auth_input_default" maxlength="64" placeholder="" value="<?php echo esc_attr($FormVal['regist_url']); ?>">
				</li>
			
				<!-- regist_captcha_enable -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Enable/Disable Captcha', 'registration-and-authorize'); ?>
					</div>
					<input class="iq_auth_tgl iq_auth_tgl_ios" id="regist_captcha_enable" name="regist_captcha_enable" type="checkbox" <?php echo esc_attr($FormVal['regist_captcha_enable']); ?>>
					<label class="iq_auth_tgl_btn" for="regist_captcha_enable"></label>
				</li>
			
				<!-- email_confirm -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Email confirmation during registration', 'registration-and-authorize'); ?>
					</div>
					<input class="iq_auth_tgl iq_auth_tgl_ios" id="email_confirm" name="email_confirm" type="checkbox" <?php echo esc_attr($FormVal['email_confirm']); ?>>
					<label class="iq_auth_tgl_btn" for="email_confirm"></label>
				</li>
			
				<!-- email_confirm_length -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Confirmation code length', 'registration-and-authorize'); ?>
					</div>
					<input type="text" id="email_confirm_length" name="email_confirm_length" class="iq_auth_input iq_auth_input_default iq_auth_max_w70 iq_auth_align_center" maxlength="10" placeholder="6" value="<?php echo esc_attr($FormVal['email_confirm_length']); ?>" onkeyup="return IQ_AUTH_OnlyNum(this.id);">
				</li>
				
				<!-- email_confirm_tries_max -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('Maximum number of incorrect verification codes entered', 'registration-and-authorize'); ?>
					</div>
					<input type="text" id="email_confirm_tries_max" name="email_confirm_tries_max" class="iq_auth_input iq_auth_input_default iq_auth_max_w70 iq_auth_align_center" maxlength="5" placeholder="6" value="<?php echo esc_attr($FormVal['email_confirm_tries_max']); ?>" onkeyup="return IQ_AUTH_OnlyNum(this.id);">
				</li>
				
				<!-- email_confirm_message -->
				<li class="iq_auth_li">
					<div class="iq_auth_li_head">
						<?php echo esc_html__('An email sent to a user with an account activation code', 'registration-and-authorize'); ?>
					</div>
					<textarea id="email_confirm_message" name="email_confirm_message" class="iq_auth_textarea iq_auth_full_width_b iq_auth_max_w700" maxlength="1000" rows="4"><?php echo esc_html($FormVal['email_confirm_message']); ?></textarea>
					<div class="iq_auth_li_about">
						<?php echo esc_html__('Use the {CODE} tag in the field to display the activation code', 'registration-and-authorize'); ?>
					</div>
				</li>
				
				<button type="submit" class="iq_auth_button_light_blue iq_auth_button_margin">
					<?php echo esc_html__('Save', 'registration-and-authorize'); ?>
				</button>
			</ul>
		</form>
		
		<!-- Copyright -->
		<div class="iq_auth_copyright_block">
			<?php
			$copyright_url = 'https://lumpx.com/wp-plugins';
			?>
			<a href="<?php echo esc_url($copyright_url); ?>" target="_blank" class="iq_auth_copyright_a">Developed by LumpX</a>
		</div>
	</div>
</div>